/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * ipc.h
 *
 *  Created on: 27/02/2011
 *      Author: raster
 */

#ifndef IPC_H_
#define IPC_H_

#include "global_vars.h"
#include "minibus/minibus.h"

struct ipc_bus_element {

	Cstring bus_name;
	uint32_t owner;
	uint32_t flags;
	uint32_t port;
	uint32_t listeners;
	bool modified;
	bool destroying;
	struct minibus_connection *connection;
	struct minibus_list subscribers;

};

struct ipc_subscriber {

	uint32_t ipc;
	struct minibus_connection *conn;
	struct ipc_bus_element *bus;
};

struct ipc_subscriber *ipc_new_subscriber(struct _client_data *client, struct ipc_bus_element *bus);
void ipc_free_subscriber(void *data);
struct ipc_bus_element *ipc_new_bus(Cstring bus_name, struct minibus_connection *connection, uint32_t owner, uint32_t port, uint32_t flags);
void ipc_free_bus(void *data);
uint32_t ipc_register_bus(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *user_data);
uint32_t ipc_unregister_bus(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *user_data);
uint32_t ipc_subscribe_to_bus(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *user_data);
uint32_t ipc_unsubscribe_to_bus(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *user_data);

#endif /* IPC_H_ */
