/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * player.h
 *
 *  Created on: 17/01/2011
 *      Author: raster
 */

#ifndef PLAYER_H_
#define PLAYER_H_

enum song_type {SONG_MP3, SONG_OGG, SONG_OTHER};
enum e_play_mode {PLAY_TITLES, PLAY_SONGS};
enum e_play_status {PLAY_STOPPED, PLAY_PLAYING, PLAY_PAUSED};
enum e_current_iface {IFACE_MAIN, IFACE_PLAY};

struct s_song {

	Cstring filename;
	enum song_type type;
	struct s_album *album;
};


struct s_album {

	Cstring path;
	uint32_t count;
	struct s_song *first_song;
	struct s_song *last_song;
};

void play_next_song();
void play_prev_song();
void play_next_album();
void play_prev_album();
void paint_iface();
uint32_t paint_main_menu();
void repaint_interface();

#endif /* PLAYER_H_ */
