/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * sampleapp.c
 *
 *  Created on: 16/09/2010
 *      Author: raster
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <signal.h>
#include <string.h>

#include "sampleapp.h"

#include "../ttos_lib/ttos.h"
#include "../minibus/minibus.h"

static volatile bool run_test;
struct minibus_master *queue;

struct ttos_sharemem_object *shmem;

uint32_t tab_id,widget_id,drawable_id,bg_id;
uint8_t text_flag,picture_flag;
bool pos;
uint32_t port1,port2;


void test_alarm_handler(int s) {
	run_test=false;
}

void run_tests(struct ttos_object *master,char *text2,uint8_t alpha,uint8_t test) {

	struct sigaction sg;
	uint8_t *memory,*pointer;
	uint32_t counter,fps,loop,x,y,size;
	struct timeval tv,tv2;
	time_t v1,v2;

	memset(&sg,0,sizeof(struct sigaction));
	sg.sa_handler=test_alarm_handler;
	sigaction(SIGALRM,&sg,NULL);

	counter=0;
	memory=malloc(307200);
	pointer=memory;
	for(loop=0;loop<76800;loop++) {
		x=loop%320;
		y=loop/320;
		*(pointer++)=(uint8_t)((x*255)/320);
		*(pointer++)=(uint8_t)((y*255)/240);
		*(pointer++)=0;
		*(pointer++)=alpha;
	}
	run_test=true;
	alarm(5);
	gettimeofday(&tv,NULL);
	while(run_test) {
		if ((test!=2)&&(test!=3))
			ttos_update_drawable(master,TTOS_SYNC_ANSWER,drawable_id,0,76800,memory, TTOS_DRAWABLE_HAS_ALPHA );
		if (test==3) {
			ttos_update_sharemem(master,shmem,0,76800,memory,TTOS_DRAWABLE_HAS_ALPHA);
		}
		if (test!=1)
			ttos_repaint_screen(master,TTOS_SYNC_ANSWER);
		counter++;
	}
	gettimeofday(&tv2,NULL);
	v1=tv2.tv_sec-tv.tv_sec;
	if (tv2.tv_usec<tv.tv_usec) {
		v1--;
		v2=1000000+tv2.tv_usec-tv.tv_usec;
	} else {
		v2=tv2.tv_usec-tv.tv_usec;
	}

	v1*=1000;
	v1+=v2/1000;

	if (v1) {
		fps=((counter*1000)/v1);
	} else {
		fps=0;
	}
	sprintf(text2,"FPS: %d r, %d ms, %d FPS",counter,(uint32_t)v1,fps);
	free(memory);
}

uint32_t cb_closed_connection(struct minibus_connection *connection,void *data) {

	exit(0);
}


#if 1
uint32_t timer_cb(uint32_t port, uint32_t answer_port, struct minibus_connection *conn,void *user_data) {

	struct ttos_object *master;
	uint16_t *pointer;
	static uint16_t r=0,g=0,b=0;
	int loop,x,y;
	int32_t retval;
	static int counter=0;

	master=user_data;

	minibus_start_message(master->conn,port1,master->ipc_uid);
	minibus_write_long(master->conn,TTOS_SR_BUS_MESSAGE);
	minibus_write_string(master->conn,"Test");
	minibus_write_long(master->conn,counter);
	minibus_send(master->conn);
	ttos_wait_for_error(master,master->ipc_uid);

	printf("Timer %d\n",counter++);

}
#endif

uint32_t bus_cb(uint32_t port, uint32_t answer_port, struct minibus_connection *connection,void *user_data) {

	struct minibus_data_element data;
	uint32_t retval;

	printf("Received bus event at port %X\n",port);

	while(1) {
		retval=minibus_read_data(connection,&data);
		if (retval) {
			break;
		}
		ttos_print_type(&data);
	}

}

uint32_t click_cb(uint32_t port, uint32_t answer_port, struct minibus_connection *connection,void *user_data) {

	struct ttos_object *master;
	static bool visible=true;
	uint32_t retval;

	master=user_data;

	if (port==54) {
		picture_flag++;
		if (picture_flag>1) {
			picture_flag=0;
		}

		switch(picture_flag) {
		case 0:
			retval=ttos_set_picture(master,TTOS_SYNC_ANSWER,bg_id,"sampleapp/crawler.tga");
		break;
		case 1:
			retval=ttos_set_picture(master,TTOS_SYNC_ANSWER,bg_id,"sampleapp/crawler2.tga");
		break;
		}
		ttos_print_error(retval,true);
		ttos_repaint_screen(master,TTOS_SYNC_ANSWER);
	} else if (port==57) {
		visible=visible ? false : true;
		ttos_set_visibility(master,TTOS_SYNC_ANSWER,widget_id,visible);
		ttos_repaint_screen(master,TTOS_SYNC_ANSWER);
	} else if (port==58) {
		text_flag++;
		if (text_flag>2) {
			text_flag=0;
		}
		switch(text_flag) {
		case 0:
			ttos_set_label_text(master,TTOS_SYNC_ANSWER,widget_id,"En un lugar de la mancha, de cuyo nombre no quiero acordarme,\nha tiempo que vivia un hidalgo de los de adarga antigua, lanza en astillero, rocin flaco, y\ngalgo corredor.",TTOS_WIDGET_FONT_MULTILINE|TTOS_WIDGET_FONT_WORD_CUT|TTOS_WIDGET_FONT_VALIGN_MIDDLE);
		break;
		case 1:
			ttos_set_label_text(master,TTOS_SYNC_ANSWER,widget_id,"Una nu/eva prueba\na ver qué tal queda esto, cortando por donde puede y no por donde no.",TTOS_WIDGET_FONT_MULTILINE|TTOS_WIDGET_FONT_WORD_CUT|TTOS_WIDGET_FONT_VALIGN_MIDDLE|TTOS_WIDGET_FONT_HALIGN_CENTER);
		break;
		case 2:
			ttos_set_label_text(master,TTOS_SYNC_ANSWER,widget_id,"Una nueva prueba larga para comprobar recorte, a ver qué tal queda esto, cortando por donde puede y no por donde no.\n\nhola",TTOS_WIDGET_FONT_MULTILINE|TTOS_WIDGET_FONT_VALIGN_TOP|TTOS_WIDGET_FONT_HALIGN_LEFT);
		break;
		}
		ttos_repaint_screen(master,TTOS_SYNC_ANSWER);
	} else if (port==59) {
		if (pos) {
			ttos_set_widget_position(master,TTOS_SYNC_ANSWER,widget_id,20,70);
			pos=false;
		} else {
			ttos_set_widget_position(master,TTOS_SYNC_ANSWER,widget_id,30,90);
			pos=true;
		}
		ttos_repaint_screen(master,TTOS_SYNC_ANSWER);
	} else if (port==60) {
		char t1[200],t2[200],t3[200],t4[200],t5[200],t6[200],t[1000];
		ttos_set_tab_offset(master,TTOS_SYNC_ANSWER,tab_id,-300,-200,TTOS_NO_ANSWER,0);
		run_tests(master,t1,0xFF,0); // copia completa sin alfa
		run_tests(master,t2,0x7F,0); // copia completa con alfa
		//run_tests(master,t3,0);
		//run_tests(master,t4,1);
		run_tests(master,t3,0xFF,2); // sólo hago repaint
		run_tests(master,t4,0xFF,3); // repaint y update_sharemem
		run_tests(master,t5,0x7F,3); // repaint y update_sharemem

		sprintf(t,"%s\n%s\n%s\n%s\n%s",t1,t2,t3,t4,t5);
		ttos_set_label_text(master,TTOS_SYNC_ANSWER,widget_id,t,TTOS_WIDGET_FONT_MULTILINE|TTOS_WIDGET_FONT_WORD_CUT|TTOS_WIDGET_FONT_VALIGN_MIDDLE);
		ttos_set_tab_offset(master,TTOS_SYNC_ANSWER,tab_id,0,0,TTOS_NO_ANSWER,0);
		ttos_repaint_screen(master,TTOS_SYNC_ANSWER);
	} else {
		struct ttos_dialog_button buttons[2];
		buttons[0].button=TTOS_CANCEL_BUTTON;
		buttons[0].return_value=1;
		buttons[1].button=TTOS_OK_BUTTON;
		buttons[1].return_value=0;

		if(0==ttos_show_dialog(master,"Exit this application?",TTOS_WIDGET_FONT_MULTILINE|TTOS_WIDGET_FONT_WORD_CUT|TTOS_WIDGET_FONT_ALIGN_CENTER,buttons,2)) {
			minibus_exit_loop(master->queue);
		}
		ttos_set_visible_tab(master,TTOS_SYNC_ANSWER,tab_id,TTOS_TAB_SWAP_MODE_REPLACE, TTOS_NO_ANSWER);
		ttos_repaint_screen(master,TTOS_SYNC_ANSWER);
	}

	/* else {
		minibus_start_message(connection,TTOS_SM_EXIT,0);
		minibus_send(connection);
	}*/

}

uint32_t main_callback(uint32_t port, uint32_t answer_port, struct minibus_connection *connection,void *user_data) {

	struct minibus_data_element data;

	printf("Recibido mensaje en puerto %X\nDatos:\n",port);


	if (port==0) {
		if (-2==minibus_read_data(connection,&data)) {
			return 0;
		}

		if ((data.type==MINIBUS_TYPE_INT32)&&(data.value32==TTOS_SR_NEW_CLIENT)) {
			minibus_read_data(connection,&data);

			minibus_start_message(connection,TTOS_SM_SET_CLIENT_WINDOW,80);
			minibus_write_long(connection,data.value32);
			minibus_write_byte(connection,0);
			minibus_send(connection);
			minibus_start_message(connection,TTOS_SM_MOVE_CLIENT_TO_FG,81);
			minibus_write_long(connection,data.value32);
			minibus_send(connection);
			return 0;
		}
		ttos_print_type(&data);
	}

	while(-2!=minibus_read_data(connection,&data)) {
		ttos_print_type(&data);
	}
	printf("\n\n");
	return 0;
}



int main(int argc,char **argv) {

	struct minibus_connection *conn;
	struct ttos_object *master;
	struct ttos_color tcolor,bgcolor;
	uint32_t retval;

	text_flag=0;
	picture_flag=0;
	pos=false;

	master=ttos_init_system(0,argc,argv);

	if (master==NULL) {
		printf("Can't connect to the queue. Aborting\n");
		exit(1);
	}

	minibus_set_default_callback(master->queue,main_callback,NULL);
	minibus_set_closed_connection_callback(master->queue,cb_closed_connection,NULL);

	retval=ttos_new_sharemem(master,TTOS_SYNC_ANSWER,320,240,true,&shmem);

	ttos_print_error(retval,true);
	printf("Sharemem: %X\n",retval);

	tab_id=ttos_new_tab(master,TTOS_SYNC_ANSWER);

	ttos_set_visible_tab(master,50,tab_id,TTOS_TAB_SWAP_MODE_REPLACE, TTOS_NO_ANSWER);
	bg_id=ttos_new_picture(master,TTOS_SYNC_ANSWER,tab_id,0,0,"sampleapp/crawler.tga",0,0);
	//retval=ttos_new_drawable_from_sharemem(master, TTOS_SYNC_ANSWER,tab_id,300,100,shmem,0,TTOS_NO_ANSWER);

	tcolor.r=tcolor.g=tcolor.b=tcolor.a=255;
	drawable_id=ttos_new_drawable_from_sharemem(master,TTOS_SYNC_ANSWER,tab_id,300,200,shmem,TTOS_DRAWABLE_HAS_ALPHA,TTOS_NO_ANSWER);
	printf("Drawable: %X\n",drawable_id);
	widget_id=ttos_new_label(master,TTOS_SYNC_ANSWER,tab_id,20,110,280,180,"En un lugar de la mancha, de cuyo nombre no quiero acordarme,\nha tiempo que vivia un hidalgo de los de adarga antigua, lanza en astillero, rocin flaco, y\ngalgo corredor.",NULL,TTOS_WIDGET_FONT_MULTILINE|TTOS_WIDGET_FONT_WORD_CUT|TTOS_WIDGET_FONT_VALIGN_MIDDLE,0);
	ttos_new_button(master,TTOS_SYNC_ANSWER,tab_id,20,1,145,30,TTOS_EXIT_BUTTON,NULL,NULL,NULL,NULL,TTOS_WIDGET_V_FIXED|TTOS_WIDGET_H_FIXED,56);
	ttos_new_button(master,TTOS_SYNC_ANSWER,tab_id,20,34,145,30,TTOS_NO_STOCK_BUTTON,NULL,"Centrar",NULL,NULL,TTOS_WIDGET_V_FIXED|TTOS_WIDGET_FONT_HALIGN_CENTER|TTOS_WIDGET_FONT_VALIGN_BOTTOM,54);
	ttos_new_button(master,TTOS_SYNC_ANSWER,tab_id,168,1,145,30,TTOS_NO_STOCK_BUTTON,NULL,"Ocultar",NULL,NULL,TTOS_WIDGET_V_FIXED|TTOS_WIDGET_FONT_HALIGN_RIGHT|TTOS_WIDGET_FONT_VALIGN_TOP,57);
	ttos_new_button(master,TTOS_SYNC_ANSWER,tab_id,168,34,145,30,TTOS_NO_STOCK_BUTTON,NULL,"Cambiar",NULL,NULL,TTOS_WIDGET_V_FIXED|TTOS_WIDGET_FONT_HALIGN_CENTER|TTOS_WIDGET_FONT_VALIGN_MIDDLE,58);
	ttos_new_button(master,TTOS_SYNC_ANSWER,tab_id,20,67,145,30,TTOS_NO_STOCK_BUTTON,NULL,"Mover",NULL,NULL,TTOS_WIDGET_H_FIXED|TTOS_WIDGET_FONT_HALIGN_CENTER|TTOS_WIDGET_FONT_VALIGN_MIDDLE,59);
	ttos_new_button(master,TTOS_SYNC_ANSWER,tab_id,168,67,145,30,TTOS_NO_STOCK_BUTTON,NULL,"Test",NULL,NULL,TTOS_WIDGET_H_FIXED|TTOS_WIDGET_FONT_HALIGN_CENTER|TTOS_WIDGET_FONT_VALIGN_MIDDLE,60);
	ttos_repaint_screen(master,TTOS_SYNC_ANSWER);
	minibus_add_callback(master->queue,54,click_cb,master);
	minibus_add_callback(master->queue,56,click_cb,master);
	minibus_add_callback(master->queue,57,click_cb,master);
	minibus_add_callback(master->queue,58,click_cb,master);
	minibus_add_callback(master->queue,59,click_cb,master);
	minibus_add_callback(master->queue,60,click_cb,master);
#if 1
	minibus_add_callback(master->queue,10,timer_cb,master);
	ttos_create_timer(master,TTOS_SYNC_ANSWER,1000,10,true);
	port1=ttos_register_bus(master,TTOS_SYNC_ANSWER,"test_bus1",TTOS_IPC_OWNER_TO_ALL);
	port2=ttos_register_bus(master,TTOS_SYNC_ANSWER,"test_bus2",TTOS_IPC_ALL_TO_OWNER);
	ttos_print_error(port1,true);
	ttos_print_error(port2,true);
	minibus_add_callback(master->queue,port2,bus_cb,master);
#endif

	minibus_run_loop(master->queue);

	printf("Salgo de loop\n");
	retval=ttos_destroy_tab(master,TTOS_SYNC_ANSWER,tab_id,0);
	printf("Tab destruida\n");
	ttos_print_error(retval,true);
	retval=ttos_destroy_sharemem(master,TTOS_SYNC_ANSWER,shmem);
	shmem=NULL;
	printf("memoria destruida\n");
	ttos_print_error(retval,true);

	ttos_destroy_system(master);
	return 0;
}
