/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * timer.h
 *
 *  Created on: 10/10/2010
 *      Author: raster
 */

#ifndef TIMER_H_
#define TIMER_H_

#define TTOS_SCROLL_TAB_SPEED 2
#define TTOS_SCROLL_TAB_TIMER 40
enum ttos_timer_type {TTOS_TIMER_USER_DEFINED, TTOS_TIMER_SCROLL_TABS, TTOS_TIMER_LONG_CLICK, TTOS_TIMER_DOUBLE_CLICK};

struct _timer {

	enum ttos_timer_type type; ///< timer type
	struct minibus_connection *conn; ///< Client's connection
	uint16_t uid; ///< Timer's UID
	uint32_t port; ///< Port to which send the timeout message
	uint64_t period; ///< Timer's period in millisecons (0 for one-shot timer)
	uint64_t instant; ///< time instant in which this timer expires
};

bool timer_compare(void *timer1, void *timer2);
uint64_t timer_get_time();
void timer_destroy(void *);
int32_t timer_timeout_callback(struct minibus_master *object,uint32_t timeout,void *data);
uint32_t timer_new_timer(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *private_data);
struct _timer *timer_init_timer(enum ttos_timer_type type,struct minibus_connection *connection,uint16_t uid,uint32_t port,uint64_t period, uint64_t instant);
uint32_t timer_delete_timer(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *private_data);
void timer_start_scroll();
bool timer_check_event(enum ttos_timer_type type, bool remove, bool add, uint64_t period);

#endif /* TIMER_H_ */
