/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * ttos_keyboard.h
 *
 *  Created on: 17/03/2011
 *      Author: raster
 */

#ifndef TTOS_KEYBOARD_H_
#define TTOS_KEYBOARD_H_

#include <stdint.h>
#include <stdbool.h>

#include "../minibus/minibus.h"
#include "ttos.h"

struct ttos_keyboard_data {

	uint32_t *key_uids;
	uint32_t tab;
	uint32_t text;
	uint32_t cancel;
	uint32_t intro;
	struct _ttos_key_buttons *keyboard;
};

struct ttos_keyboard_data *ttos_new_keyboard(struct ttos_object *master, uint8_t type, Cstring text, bool scroll);
Cstring ttos_keyboard_intro(struct ttos_object *master,Cstring o_text);
int32_t ttos_ask_for_digit(struct ttos_object *master,Cstring text, uint32_t size, int32_t value, uint32_t min, uint32_t max, enum ttos_stock_button next_button);

#endif /* TTOS_KEYBOARD_H_ */
