/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * ttos_manager.h
 *
 *  Created on: 29/11/2010
 *      Author: raster
 */

#ifndef TTOS_MANAGER_H_
#define TTOS_MANAGER_H_

#define TTOS_MANAGER_PROGRAM_FOLDER "programs"

struct manager_app {
	struct manager_running *running;
	Cstring launch_command;
	Cstring icon;
	uint32_t icon_id;
};

struct manager_running {

	uint32_t uid;
	Cstring program;
	struct manager_app *app;

};

struct manager_app* manager_new_app(Cstring program,Cstring icon);
void manager_destroy_app(void *data);
int32_t manager_show_dialog(struct ttos_object *master, Cstring text, uint32_t text_flags, struct ttos_dialog_button *buttons, uint16_t count);

#endif /* TTOS_MANAGER_H_ */
