/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * uid.h
 *
 *  Created on: 19/12/2010
 *      Author: raster
 */

#ifndef UID_H_
#define UID_H_

#include <stdint.h>
#include <stdbool.h>

// Number of UIDs to serve, divided by 8. We want to serve up to 4096 different UIDs
#define TTOS_UID_SIZE 512

struct ttos_uid_c {

	uint8_t bitmask[TTOS_UID_SIZE]; ///< Stores a bit for each UID, to easily detect the used and free ones
};

struct ttos_uid_c *uid_init();
void uid_destroy(struct ttos_uid_c *object);
uint32_t uid_get_uid(struct ttos_uid_c *object, uint32_t type);
void uid_release_uid(struct ttos_uid_c *object, uint32_t uid);
uint32_t uid_mix_uid(uint16_t w_uid, uint16_t t_uid, uint32_t type_mask);

#endif /* UID_H_ */
